-- == SRB2Randomizer: Ringslinger "support" ==
-- (No, I don't want to support Ringslinger, so I coded this in 10 minutes.)

addHook("ThinkFrame", function()
	if (randomizer.seed == nil or randomizer.rv == nil)
		return
	end

	if not (G_RingSlingerGametype()) -- if not (gametype == GT_COOP)
		return
	end

	for p in players.iterate()
		if (p.mo and p.mo.valid)
			p.mo.type = MT_GARGOYLE
			p.mo.state = mobjinfo[MT_GARGOYLE].spawnstate

			p.powers[pw_shield] = SH_NONE
			p.powers[pw_underwater] = 0
			p.powers[pw_spacetime] = 0

			if (p.randomizer.gargoyleangle == nil)
				p.randomizer.gargoyleangle = p.mo.angle
			end

			p.mo.angle = p.randomizer.gargoyleangle

			if (p.mo.momx or p.mo.momy)
			and not (S_SoundPlaying(p.mo, sfx_statu2))
				S_StartSound(p.mo, sfx_statu2)
			end

			p.mo.momx = 0
			p.mo.momy = 0

			p.pflags = $1|PF_JUMPSTASIS|PF_USEDOWN
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if (randomizer.seed == nil or randomizer.rv == nil)
		return
	end

	if not (G_RingSlingerGametype())
		return
	end

	p.randomizer.gargoyleangle = randomizer.rv
	randomizer.rv = randomizer.scramble(randomizer.rv)
end)
